#include<stdio.h>
#include<string.h>
#include<malloc.h>

class String;

//  
struct Concat{
	String &s1;
	String &s2;
	Concat(String &s1,String &s2):s1(s1),s2(s2) {}
};

//  
class String{
	int size;
	char *buff;
public:
	String() {buff=0;size=0;}
	String(const char *t) {size=strlen(t); buff=strdup(t);}
	String(Concat &con) {buff=0;operator=(con);}
	~String() {free(buff);}
	char *data() {return buff;}
	void operator=(Concat &con) {
		size=con.s1.size+con.s2.size;
		buff=(char*)realloc(buff,size+1);
		memcpy(buff,con.s1.buff,con.s1.size);
		memcpy(buff+con.s1.size,con.s2.buff,con.s2.size);
		buff[size]=0;
	}
};

static Concat operator+(String &s1,String &s2) {return Concat(s1,s2);}

int main()
{
	String s1("test1");
	String s2("test2");
	String s3=s1+s2;
	printf("%s\n",s3.data());
	return 0;
}

